# -*- coding: utf-8 -*-
import wave
import numpy as np
from numpy import *
import scipy.signal
from pylab import *
import pyaudio
import scipy.fftpack
import time
import subprocess
pa = pyaudio.PyAudio()

#unichr(int(format(ord(u"あ"),"b"),2)).encode("utf-8")

wf300 = wave.open("300.wav", "r")
buffer = wf300.readframes(wf300.getnframes())
data300 = list(frombuffer(buffer, dtype="int16"))
wfstart = wave.open("start.wav", "r")
buffer = wfstart.readframes(wfstart.getnframes())
datastart = list(frombuffer(buffer, dtype="int16"))
wf1470 = wave.open("2205.wav", "r")
buffer = wf1470.readframes(wfstart.getnframes())
data1470 = list(frombuffer(buffer, dtype="int16"))[:]
wf1470w = wave.open("2205w.wav", "r")
buffer = wf1470w.readframes(wfstart.getnframes())
data1470w = list(frombuffer(buffer, dtype="int16"))[:]

class AAsk:
	def __init__(self):
		self.callsign = "je1ocv"

class Send(AAsk):
	def __init__(self):
		AAsk.__init__(self)
		self.hz = 2205
		#self.callsign = "je1ocv"

	def text2bin(self, text):#余ったところを埋める0は前に。
		bindata = ""
		binone = ""
		for one in text:
			binone = format(ord(one), "b")
			while len(binone) < 8:
				binone = "0" + binone
			bindata = bindata + binone
		#print "end of text2bin"
		return(bindata)

	def bin2fsk(self, bindata, distcall):#bindataは0と1の文字列
		p = pyaudio.PyAudio()
		stream = p.open(format =
					p.get_format_from_width(wf300.getsampwidth()),
					channels = 1,
					rate = wf300.getframerate(),
					output = True,
					frames_per_buffer = 1024)
	
		sound_data = []
		for cnt in range(1000):
			sound_data.append(0)
			
		sound_data = sound_data + datastart[:]
		sound_data = sound_data + data1470[:] + data1470w[:] + data1470[:] + data1470w[:]
		sound_data = sound_data + data1470[:]+data1470[:]+data1470[:]+data1470w[:]+data1470w[:]
	
		size = len(bindata)
		sizebin = format(len(bindata),"b")
		while len(sizebin) < 32:
			sizebin = "0" + sizebin
			
		distcallbin = self.text2bin(distcall)
		while len(distcallbin) < 80:
			distcallbin = "0" + distcallbin
		#print distcallbin
	
		callbin = self.text2bin(self.callsign)
		while len(callbin) < 80:
			callbin = "0" + callbin
		#print callbin
	
		bindata = callbin + distcallbin + sizebin + bindata
		#print "size"
		#print size
		#print sizebin
		#print bindata
		#print len(bindata)
	
		cnt = 0
		for binone in bindata:
			#print cnt
			if binone == "1":
				sound_data.extend(data1470w)
			else:# binone == "0":
				sound_data.extend(data1470)
			cnt = cnt + 1
			
		rest = len(sound_data) % 1024
		cnt = 1
		str_sound_data = int16(array(sound_data)).tostring()
		stream.write(str_sound_data,len(sound_data)*2)
    
class Receive(AAsk):
	def __init__(self):
		AAsk.__init__(self)
		self.hz = 882
		self.standard = []
		self.strong = 0
		self.weak = 0

		#self.gap90 = csv.reader(open("90.csv", 'rb'))
		#self.gap180 = csv.reader(open("180.csv", 'rb'))
		#self.gap270 = csv.reader(open("270.csv", 'rb'))
		
	def fft(self, x, fs):
		x = list(x)
		N = 1024

		for i in range(N):
			#b.append(0.0)
			x.append(0.0)
			
		start = 0
		X = np.fft.fft(x[start:start+N])
		#X = scipy.fftpack.fft(x[start:start+N])         # scipy

		freqList = np.fft.fftfreq(N, d=1.0/fs)
		#freqList = scipy.fftpack.fftfreq(N, d=1.0/ fs)  # scipy

		amplitudeSpectrum = [np.sqrt(c.real ** 2 + c.imag ** 2) for c in X]

		subplot(311)
		plot(range(start, start+N), x[start:start+N])
		axis([start, start+N, -1.0, 1.0])
		xlabel("time [sample]")
		ylabel("amplitude")
	
		subplot(312)
		plot(freqList, amplitudeSpectrum, marker= 'o', linestyle='-')
		axis([0, fs/2, 0, 50])
		xlabel("frequency [Hz]")
		ylabel("amplitude spectrum")
		spec = amplitudeSpectrum
		if abs(spec.index(max(spec)) - 10) < 2 and max(spec) / 4 > np.std(spec[5:20]) and max(spec) > 20:
			#show()
			pass
			
		return(amplitudeSpectrum)
		
	def decode(self):
		amplitude = 0
		x = []
		x.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
		x.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
		x.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
		for er in range(100):
			x.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
			if (x[len(x) - 2] > x[len(x) - 1])  != (x[len(x) - 3] > x[len(x) - 2]):
				v = []
				v.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
				v.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
				v.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
				while (v[len(v) - 2] > v[len(v) - 1])  == (v[len(v) - 3] > v[len(v) - 2]):
					v.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
				break
		amplitude = abs(min(x)) + abs(max(v))
		#print len(v)
		return(amplitude)
		
	def decode2bin(self):
		amplitude = self.decode()
		if amplitude > self.strong * 0.6:
			return("0")
		elif amplitude > self.weak * 0.5:
			return("1")
		else:
			return("")
			#print "error"
			#exit()
			
	def decode_main(self, max_strength):
		decoded = []
		plus = []
		delay = 0
		x = []
		strength_pre = 0
		strength_post = 0
		tmpbin = ""
		
		self.decode()
		first = self.decode()
		second = self.decode()
		
		if first > second:#基準となる振幅の取得
			self.strong = first
			self.weak = second
		elif second > first:
			self.strong = second
			self.weak = first
		
		datasizebin = ""
		theircall = ""
		#theircallbin = ""
		distcall = ""
		
		while True:
			if self.decode2bin() == "1":
				if self.decode2bin() == "1":
					break
		print "start"
		
		for cnt in range(10):
			decoded = ""
			while len(decoded) < 8:
				decoded = decoded + self.decode2bin()
			#print int(decoded, 2)
			theircall = theircall + chr(int(decoded, 2))
			#print chr(int(decoded, 2))
		print theircall
		
		for cnt in range(10):
			decoded = ""
			while len(decoded) < 8:
				decoded = decoded + self.decode2bin()
			#print int(decoded, 2)
			distcall = distcall + chr(int(decoded, 2))
			#print chr(int(decoded, 2))
		print distcall
		
		for cnt in range(32):#データのサイズを取得
			datasizebin = datasizebin + self.decode2bin()
		#print datasizebin
		datasize = int(datasizebin, 2)
		print datasize
		
		decoded = ""
		decoded_text = ""
		for we in range(datasize/8):
			decoded = ""
			while len(decoded) < 8:
				decoded = decoded + self.decode2bin()
			#print int(decoded, 2)
			decoded_text = decoded_text + chr(int(decoded, 2))
			#print chr(int(decoded, 2))
			#print decoded
		print decoded_text
		#savefile = open(,"wb")
		#savefile.write(decoded_text)
		#savefile.close()
		return(theircall, distcall, decoded_text)
			
	def main(self):
		self.stream = pa.open(format = pyaudio.paInt16,channels = 1, rate = 44100, input = True,output = True,frames_per_buffer = 20480)
		#fsk = Fsk()
		sig = 3
		while True:
			x = frombuffer(self.stream.read(2205),dtype = "int16") / 32768.0
			spec = self.fft(x, 44100)
			if abs(spec.index(max(spec)) - 10) < 3 and max(spec) / 2 > np.std(spec[5:8] + spec[12:30]) and max(spec) > 10:
				print "Start!"
				max_strength = max(list(x))#最大値取得
				x = list(frombuffer(self.stream.read(100),dtype = "int16") / 32768.0)
				while max(x) > 0.1:#無音になるまで待つ
					x = list(frombuffer(self.stream.read(100),dtype = "int16") / 32768.0)
				print max(x)
				print max_strength
				print "ahaha"
				x = float(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)
				while abs(x) < max_strength * 0.2:#無音が終わるまで待つ
					x = float(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)
					print x
				print np.average(x)
				print "end"

				if abs(x) == x:
					peak = True
				else:
					peak = False

				for cnt in [1,2]:
					sig = peak
					while sig == peak:
						x = float(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)
						if abs(x) == x:
							sig = True
						else:
							sig = False
						print x
					if peak == True:
						peak = False
					else:
						peak = True
				#print self.decode_main(abs(max_strength))
				return(self.decode_main(abs(max_strength)))

if __name__ == "__main__":
	send = Send()
	aask = AAsk()
	receive = Receive()
	
	print receive.main()
